(function($) {
  var gmap__constructor = function($map) {
    // MARKERS
    $markers = $map.find('.marker');
    // SETUP
    var KEY = $map.attr('data-key');
    var LANGUAGE = $map.attr('data-lang');
    // DEFAULT
    var ID = "_googlemap_";
    var URL = "https://maps.googleapis.com/maps/api/js";
    // INIT
    var initMap = function() {
      // CREATE MAP
      var map = new google.maps.Map(document.getElementById('map'), {
        zoom: 4
      });
      // CREATE MARKERS
      $markers.each(function(i, el) {
        var marker = {
          'lat': parseInt($(el).attr('data-lat')),
          'lng': parseInt($(el).attr('data-lng')),
          'html': $(el).html()
        }
        addMarkers(map, marker);
      });
    }
    // ADD MARKERS
    var addMarkers = function(map, marker) {
      var uluru = {
        lat: marker.lat,
        lng: marker.lng
      };
      var marker = new google.maps.Marker({
        position: uluru,
        map: map
      });
      map.setCenter(uluru)
    }
    if (KEY) {
      URL += '?key=' + KEY;
    }
    if (LANGUAGE) {
      URL += '&language=' + LANGUAGE;
    } else {
      URL += '&language=es';
    }
    if ($("#" + ID).length === 0) {
      script = document.createElement('script');
      script.type = 'text/javascript';
      script.src = URL;
      script.id = ID;
      script.async = true;
      script.defer = true;
      document.body.appendChild(script);
    }
    var loading = setInterval(function() {
      if (window.google !== undefined) {
        window.clearInterval(loading);
        initMap();
      }
    }, 100);
  }
  // Custom
  $.fn.gmaps = function() {
    return this.each(function() {
      $map = $(this);
      if (!$map.hasClass('gmap-load')) {
        $map.addClass('gmap-load');
        gmap__constructor($map);
      } else {
        return false;
      }
    });
  };
  // Automatic
  $.gmaps = function() {
    $('body').find('a.gmap').each(function(i, e) {
      $(e).addClass('gmap-auto');
      $(e).gmaps();
    });
  }
})(jQuery);